<?xml version="1.0" encoding="UTF-8"?>
<!--
Copyright 2021 Google LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
-->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">

	<modelVersion>4.0.0</modelVersion>
	<groupId>apigee-devrel</groupId>	
	<artifactId>${project.name}</artifactId>
	<version>${apigee.apiversion}</version>
	<name>${project.name}${deployment.suffix}</name>
	<packaging>pom</packaging>

	<properties>
		<project.name>WebHooks-HUB</project.name>
		<project.name.outproxy>WebHooks-HUB</project.name.outproxy>
		<project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
		<project.reporting.outputEncoding>UTF-8</project.reporting.outputEncoding>
		<org.slf4j.simpleLogger.defaultLogLevel>info</org.slf4j.simpleLogger.defaultLogLevel>
		<project.root.dir>${basedir}</project.root.dir>
		<target.root.dir>${basedir}/target</target.root.dir>
		<deployment.suffix></deployment.suffix>
		<apigee.options>override</apigee.options>
		<apigee.apiversion>v1</apigee.apiversion>
		<apigee.org>${org}</apigee.org>
		<apigee.env>${env}</apigee.env>
		<deployment.description>n/a</deployment.description>
	</properties>

	<pluginRepositories>
		<pluginRepository>
			<id>central</id>
			<name>Maven Plugin Repository</name>
			<url>https://repo.maven.apache.org/maven2</url>
			<layout>default</layout>
		</pluginRepository>
	</pluginRepositories>
	
	<repositories>
		<repository>
			<id>central</id>
			<name>Central Repository</name>
			<url>https://repo.maven.apache.org/maven2</url>
			<layout>default</layout>
			<snapshots>
				<enabled>false</enabled>
			</snapshots>
		</repository>
	</repositories>
	
	<profiles>
		<profile>
			<!-- Current Generation SaaS -->
			<id>apigeeapi</id>
			<properties>
				<apigee.plugin.version>1.2.2</apigee.plugin.version>
				<apigee.hosturl>https://api.enterprise.apigee.com</apigee.hosturl>
				<apigee.authtype>oauth</apigee.authtype>
				<apigee.username>${username}</apigee.username>
				<apigee.password>${password}</apigee.password>
			</properties>
			<build>
				<plugins>
					<plugin>
						<groupId>com.apigee.edge.config</groupId>
						<artifactId>apigee-config-maven-plugin</artifactId>
						<version>1.4.3</version>
						<executions>
							<execution>
								<id>create-config-cache</id>
								<phase>install</phase>                        
								<goals>
									<goal>caches</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-kvm</id>
								<phase>install</phase>                        
								<goals>
									<goal>keyvaluemaps</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-resourcefiles</id>
								<phase>install</phase>                        
								<goals>
									<goal>resourcefiles</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-keystores</id>
								<phase>install</phase>                        
								<goals>
									<goal>keystores</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-aliases</id>
								<phase>install</phase>                        
								<goals>
									<goal>aliases</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-references</id>
								<phase>install</phase>                        
								<goals>
									<goal>references</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-targetserver</id>
								<phase>install</phase>                        
								<goals>
									<goal>targetservers</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-apiproduct</id>
								<phase>install</phase>                        
								<goals>
									<goal>apiproducts</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-developer</id>
								<phase>install</phase>                        
								<goals>
									<goal>developers</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-app</id>
								<phase>install</phase>                        
								<goals>
									<goal>apps</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-reports</id>
								<phase>install</phase>                        
								<goals>
									<goal>reports</goal>
								</goals>
							</execution>
							<execution> 
								<id>create-config-flowhooks</id>
								<phase>install</phase>
								<goals>
									<goal>flowhooks</goal>
								</goals>
							</execution>
							<execution> 
								<id>create-config-userroles</id>
								<phase>install</phase>
								<goals>
									<goal>userroles</goal>
								</goals>
							</execution>
							<execution> 
								<id>import-keys</id>
								<phase>install</phase>
								<goals>
									<goal>importKeys</goal>
								</goals>
							</execution>
						</executions>
					</plugin>            
				</plugins>
			</build>
	
		</profile>



		<profile>
			<!-- Next Generation SaaS and hybrid -->
			<id>googleapi</id>
			<properties>
				<apigee.plugin.version>2.1.0</apigee.plugin.version>
				<apigee.hosturl>https://apigee.googleapis.com</apigee.hosturl>
				<apigee.bearer>${token}</apigee.bearer> <!-- this takes precedence over service account file -->
				<apigee.serviceaccount.file>${sa}</apigee.serviceaccount.file>
			</properties>
			<build>
				<plugins>
					<!-- APIGEE CONFIG -->
					<!-- apigee deploy config 2.1.0 -->
					<plugin>
						<groupId>com.apigee.edge.config</groupId>
						<artifactId>apigee-config-maven-plugin</artifactId>
						<version>2.1.0</version>
						<executions>
							<execution>
								<id>create-config-references</id>
								<phase>install</phase>                        
								<goals>
									<goal>references</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-targetserver</id>
								<phase>install</phase>                        
								<goals>
									<goal>targetservers</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-kvm</id>
								<phase>install</phase>                        
								<goals>
									<goal>keyvaluemaps</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-resourcefiles</id>
								<phase>install</phase>                        
								<goals>
									<goal>resourcefiles</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-apiproduct</id>
								<phase>install</phase>                        
								<goals>
									<goal>apiproducts</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-developer</id>
								<phase>install</phase>                        
								<goals>
									<goal>developers</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-app</id>
								<phase>install</phase>                        
								<goals>
									<goal>apps</goal>
								</goals>
							</execution>
							<execution>
								<id>create-config-reports</id>
								<phase>install</phase>                        
								<goals>
									<goal>reports</goal>
								</goals>
							</execution>
							<execution> 
								<id>create-config-flowhooks</id>
								<phase>install</phase>
								<goals>
									<goal>flowhooks</goal>
								</goals>
							</execution>
						</executions>
					</plugin> 
				</plugins>
			</build>
		</profile>
	</profiles>


	<build>
		<pluginManagement>
			<plugins>
				<plugin>
					<groupId>io.apigee.build-tools.enterprise4g</groupId>
					<artifactId>apigee-edge-maven-plugin</artifactId>
					<version>${apigee.plugin.version}</version>
				</plugin>
			</plugins>
		</pluginManagement>

		<plugins>
			<!-- APIGEE DEPLOY -->
			<!-- copy the full apiproxy folder to target folder -->
			<plugin>
				<artifactId>maven-resources-plugin</artifactId>
				<version>2.6</version>
				<executions>
					<execution>
						<id>copy-resources</id>
						<phase>process-resources</phase>
						<goals>
							<goal>copy-resources</goal>
						</goals>
						<configuration>
							<overwrite>true</overwrite>
							<resources>
								<resource>
									<directory>${project.root.dir}</directory>
									<filtering>true</filtering>
									<includes>
										<include>apiproxy/**</include>
										<include>test/integration/**</include>
										<include>resources/**</include>
									</includes>
								</resource>
							</resources>
							<outputDirectory>${target.root.dir}</outputDirectory>
						</configuration>
					</execution>
				</executions>
			</plugin>

			<plugin>
				<groupId>com.google.code.maven-replacer-plugin</groupId>
				<artifactId>replacer</artifactId>
				<version>1.5.3</version>
				<executions>
					<execution>
						<phase>process-resources</phase>
						<goals>
							<goal>replace</goal>
						</goals>
					</execution>
				</executions>
				<configuration>
					<basedir>${target.root.dir}</basedir>
					<includes>
						<include>test/integration/support/init.js</include>		
						<include>apiproxy/${project.name.outproxy}.xml</include>				
						<include>apiproxy/proxies/default.xml</include>
					</includes>
					<replacements>
						<replacement>
							<token>org-env.apigee.net</token>
							<value>${apigee.org}-${apigee.env}.apigee.net</value>
						</replacement>
						<replacement>
							<token>/${project.name}/${apigee.apiversion}</token>
							<value>/${project.name}${deployment.suffix}/${apigee.apiversion}</value>
						</replacement>
						<replacement>
							<token>@description</token>
							<value>${deployment.description}</value>
						</replacement>
					</replacements>
				</configuration>
			</plugin>

			<plugin>
				<groupId>io.apigee.build-tools.enterprise4g</groupId>
				<artifactId>apigee-edge-maven-plugin</artifactId>
				<version>${apigee.plugin.version}</version>
				<executions>
					<execution>
						<id>configure-bundle-step</id>
						<phase>package</phase>
						<goals>
							<goal>configure</goal>
						</goals>
					</execution>
					<!--deploy bundle -->
					<execution>
						<id>deploy-bundle-step</id>
						<phase>deploy</phase>
						<goals>
							<goal>deploy</goal>
						</goals>
					</execution>
				</executions>
			</plugin>

			<!-- cleaning dirs -->
			<plugin>
				<artifactId>maven-clean-plugin</artifactId>
				<version>2.5</version>
				<executions>
					<execution>
						<id>auto-clean-init</id>
						<phase>initialize</phase>
						<goals>
							<goal>clean</goal>
						</goals>
					</execution>
				</executions>
			</plugin>
		</plugins>
	</build>
</project>